var fs = require("fs");
var basePath = __dirname;
var path  = require("path");

function getParentPath(filePath){
    return path.resolve(filePath,"..");
}

function makeDir(filePath) {
    var iter = function(parent) {
      if (!fs.existsSync(parent)) {
        var f = getParentPath(parent);
        iter.call(this,f);
        fs.mkdirSync(parent);
      }
    };
    var parent = getParentPath(filePath);
    iter.call(this,parent);
    if (!fs.existsSync(filePath)) {
      fs.mkdirSync(filePath);
    }
}

/**
 * 判断是否目录
 * @param {String} filePath  目标路径
 * @param {Boolean} create 不存在时是否创建
 */
function isDirectory(filePath,create){
    if(filePath){
        if(fs.existsSync(filePath) && fs.statSync(filePath).isDirectory()){
            return true;
        }else if(create === true){
            try{
                fs.mkdirSync(filePath);
                return true;
            }catch(e){
                console.log("无法创建目录，已忽略.");
            }
        }
    }
    return false;
}
/**
 * 判断是否目录
 * @param {String} filePath 目标路径
 */
function isFile(filePath){
    if(filePath && fs.existsSync(filePath) && fs.statSync(filePath).isFile()){
        return true;
    }
    return false;
}
/**
 * 获取文件名称
 * @param {String} filePath 文件路径
 */
function getFileName(filePath){
    var name = null;
    if(filePath){
        var pathArr = filePath.replace(/\\/g, "/").split("/");
        name = pathArr[pathArr.length - 1];
    }
    return name;
}
/**
 * 复制资源文件到指定目录
 * @param {String} targetPath 目标目录
 * @param {String} type 终端类型：ios/android
 */
function CopyV3PlatformVuiResource(targetPath,type){
    var results = [];
    if(isDirectory(targetPath)){
        var paths = ['resources/page/itop/common/f7/skin/css/f7.min.css'];
        switch(type){
            case "android" :
                paths.push('resources/page/itop/common/f7/skin/css/f7.md.min.css');
                break;
            default :
                paths.push('resources/page/itop/common/f7/skin/css/f7.ios.min.css');
                break;
        }
        /* 创建目录 */
        makeDir(path.resolve(targetPath,"f7/css"));
        for(var i =0,len = paths.length;i<len;i++){
            var filePath = path.resolve(basePath, paths[i]);
            var fileName = getFileName(filePath);
            var tPath = "f7/css" + "/" + fileName;
            fs.copyFileSync(filePath,path.resolve(targetPath, tPath));
            results.push(tPath);
        }
    }else{
        console.log("目标目录不存在，已忽略复制操作.");
    }
    return results;
}

function getStyleResources(){
    return {
        "base": [
            []
        ]
    }
}

module.exports = {
    CopyV3PlatformVuiResource : CopyV3PlatformVuiResource
}